// Keyboard communication routines

#ifndef __KB_INCLUDED
#define __KB_INCLUDED

#include "kbpindefs.h"
#include "inttypes.h"

//#define ISC00 0
//#define ISC01 1

uint8_t debug_ps2;
uint8_t kb_lock;

void init_kb(void);
unsigned int decode(unsigned char sc);
void put_kbbuff(unsigned char c);
int ps2getchar(void);
void ps2proc_char(void);

__inline__ void release_kb_clock(void);
__inline__ void grab_kb_clock(void);

#ifdef BENCHMARK
uint8_t kbuf_comm(uint8_t i);
#endif
uint8_t ps2_stat_comm(uint8_t i);


#define PS2_STAT_COMMBYTES 16

// some of these are actually scancodes, but can be 
// any other free codes
#define KEY_F1	0xf1
#define KEY_F2	0xf2
#define KEY_F3	0xf3
#define KEY_F4	0xf4
#define KEY_F5	0xf5
#define KEY_F6	0xf6
// the F7 is unhandled, code is 0x83, above 0x80...
#define KEY_F7	0xf7
#define KEY_F8	0xf8
#define KEY_F9	0xf9
#define KEY_F10	0xfa
#define KEY_F11 0xfb
#define KEY_F12	0xfc

#define KEY_ESC		1
#define KEY_INS		0X81
#define KEY_HOME	0x82
#define KEY_PGUP	0x83
#define KEY_DEL		0x84
#define KEY_END		0x85
#define KEY_PGDN	0x86
#define KEY_UPARROW 0x8a
#define KEY_LEFTARROW 0x90
#define KEY_DNARROW	0x91
#define KEY_RIGHTARROW 0x92
#define KEY_GRSLASH 	0xa0
#define KEY_CTRL        0xa1
#define KEY_ALT         0xa2

// for kbflags:
enum { is_up, lshift, rshift, lalt, ralt, is_e0 };


#endif

