
#ifndef __PID_H__
#define __PID_H__

struct pid_t {
	uint16_t target;
	uint16_t prev;
	int16_t integral;
	// TODO: parameters pointer should not be stored in SRAM
	// as for a given pid_t always the same (casted from config.something_pid_kp)
	// is used - which could be passed to each routine using a convenience
	// macro - similar to I259()
	struct pid_parameters_t *parameters;
};

struct pid_parameters_t {
	uint8_t kp;
	uint8_t ki;
	uint8_t kd;
	uint8_t integral_limit;
};

void pid_init(struct pid_t *p, struct pid_parameters_t *parameters);
void pid_set_target(struct pid_t *p, uint16_t target);
int16_t pid15(struct pid_t *p, uint16_t current);


#endif
